VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TileSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private mTiles As StdPicture
Private mTileCount As Integer
Private mTilesPerRow As Integer
Private mTileWidth As Integer
Private mTileHeight As Integer
Private mZoom As Integer

Public Property Get Zoom() As Integer
    Zoom = mZoom
End Property

Public Property Let Zoom(newZoom As Integer)
    mZoom = newZoom
    Do While RenderWidth < 1 Or RenderHeight < 1
        mZoom = mZoom + 1
    Loop
End Property

Public Property Get RenderWidth()
    RenderWidth = mTileWidth * (2 ^ mZoom)
End Property

Public Property Get RenderHeight()
    RenderHeight = mTileHeight * (2 ^ mZoom)
End Property

Private Function TileX(TileIndex As Integer)
    TileX = (TileIndex Mod mTilesPerRow) * mTileWidth
End Function

Private Function TileY(TileIndex As Integer)
    TileY = (TileIndex \ mTilesPerRow) * mTileHeight
End Function

Public Property Get Count()
    Count = mTileCount
End Property

Public Sub Draw(TileIndex As Integer, Dest As PictureBox, xd As Integer, yd As Integer)
    If TileIndex >= 0 And TileIndex < Count Then
        'If the tile index is valid then draw the tile
        Dest.PaintPicture mTiles, xd, yd, RenderWidth, RenderHeight, TileX(TileIndex), TileY(TileIndex), mTileWidth, mTileHeight, vbSrcCopy
    Else
        'Otherwise, draw a grey hatched pattern
        Dest.DrawStyle = vbInsideSolid
        Dest.ForeColor = vb3DShadow
        Dest.Line (xd, yd)-(xd + RenderWidth - 1, yd + RenderHeight - 1), , BF
    End If
End Sub

Public Sub LoadFromBitmap(Filename As String)
    Set mTiles = LoadPicture(Filename)
    mTilesPerRow = PicXToPixel(mTiles.Width) \ mTileWidth
    mTileCount = mTilesPerRow * (PicYToPixel(mTiles.Height) \ mTileHeight)
End Sub

Public Property Get Tiles()
    Set Tiles = mTiles
End Property

Public Property Get TilesPerRow()
    TilesPerRow = mTilesPerRow
End Property

Public Sub LoadFromTileSet(t As TileSet)
    Set mTiles = t.Tiles
    mTilesPerRow = t.TilesPerRow
    mTileCount = t.Count
End Sub

Private Sub Class_Initialize()
    Set mTiles = Nothing
    mTileCount = 0
    mTilesPerRow = 13
    mTileWidth = 16
    mTileHeight = 16
    mZoom = 0
End Sub

Public Function PixelWToTiles(w As Integer)
    PixelWToTiles = (w + RenderWidth - 1) \ RenderWidth
End Function

Public Function PixelHToTiles(h As Integer)
    PixelHToTiles = (h + RenderHeight - 1) \ RenderHeight
End Function

Public Function Clone() As TileSet
    Dim NewSet As New TileSet
    NewSet.LoadFromTileSet Me
    Set Clone = NewSet
End Function

Public Property Get Width()
    Width = mTileWidth
End Property

Public Property Get Height()
    Height = mTileHeight
End Property

