Attribute VB_Name = "Utils"
Private Const TwipsPerDecimeter = 5669

Public Declare Function SetCursorPos Lib "USER32" ( _
    ByVal x As Long, _
    ByVal y As Long _
    ) As Long

Public Type RECT
    Left As Long
    TOp As Long
    Right As Long
    Bottom As Long
End Type

Public Declare Function GetWindowRect Lib "USER32" ( _
    ByVal hWnd As Long, _
    lpRect As RECT _
    ) As Long
    
Private Declare Function GetPrivateProfileString Lib "Kernel32" Alias "GetPrivateProfileStringA" ( _
    ByVal lpAppName As String, _
    ByVal lpKeyName As String, _
    ByVal lpDefault As String, _
    ByVal lpReturnedString As String, _
    ByVal nSize As Long, _
    ByVal lpFileName As String _
    ) As Long

Private Declare Function WritePrivateProfileString Lib "Kernel32" Alias "WritePrivateProfileStringA" ( _
    ByVal lpAppName As String, _
    ByVal lpKeyName As String, _
    lpString As Any, _
    ByVal lpFileName As String _
    ) As Long



Function PicXToPixel(ByVal xHiMetric As Long) As Long
    PicXToPixel = xHiMetric * TwipsPerDecimeter / Screen.TwipsPerPixelX / 10000
End Function

Function PicYToPixel(ByVal yHiMetric As Long) As Long
    PicYToPixel = yHiMetric * TwipsPerDecimeter / Screen.TwipsPerPixelY / 10000
End Function

Function fScaleX(ByVal x As Single, ByVal smfrom As ScaleModeConstants, ByVal smto As ScaleModeConstants) As Single
    If smfrom = vbTwips Then x = x / Screen.TwipsPerPixelX
    If smto = vbTwips Then x = x * Screen.TwipsPerPixelX
    fScaleX = x
End Function

Function fScaleY(ByVal y As Single, ByVal smfrom As ScaleModeConstants, ByVal smto As ScaleModeConstants) As Single
    If smfrom = vbTwips Then y = y / Screen.TwipsPerPixelY
    If smto = vbTwips Then y = y * Screen.TwipsPerPixelY
    fScaleY = y
End Function

Public Sub MoveCursor(ByRef o As Object, ByVal x As Long, ByVal y As Long)
    Dim r As RECT
    
    Call GetWindowRect(o.hWnd, r)
    Call SetCursorPos(r.Left + x, r.TOp + y)
End Sub

Public Function GetINISetting(sSection, sSetting) As String
    Dim sBuffer As String, nChars As Long
    sBuffer = String(256, 0)
    nChars = GetPrivateProfileString(sSection, sSetting, "", sBuffer, Len(sBuffer), GetINIFileName())
    sBuffer = Left(sBuffer, nChars)
    GetINISetting = sBuffer
End Function

Public Sub SaveINISetting(sSection, sSetting, Optional sValue As Variant = Null)
    Dim s As String
    If IsNull(sValue) Then
        Call WritePrivateProfileString(sSection, sSetting, ByVal 0&, GetINIFileName())
    Else
        s = CStr(sValue)
        Call WritePrivateProfileString(sSection, sSetting, ByVal s, GetINIFileName())
    End If
End Sub

Private Function GetINIFileName() As String
    Dim s As String
    s = App.Path
    If Right(s, 1) <> "\" Then s = s & "\"
    s = s & App.Title & ".ini"
    GetINIFileName = s
End Function
